function [Courbes,Moments]=A_Monte_Carlo(F,Psis,Nsample,Interval,Min,Max,h)
Npsi=size(Psis,1);
Nvar=size(Psis,2);
Ninter=round((Max-Min)/Interval);
Courbes=zeros(Ninter,4);
Moments=zeros(1,4);
Moy=F(1,1);
Random=zeros(1,Nvar);
for inter=1:Ninter
    centre_inter=Min+(inter-0.5)*Interval;
    Courbes(inter,1)=centre_inter;
end

for sample=1:Nsample
    Output=0;
    Random=randn(1,Nvar);
    for psi=1:Npsi
        valeurpsi=1;
        for var=1:Nvar
            if Psis(psi,var)==1
                valeurpsi=valeurpsi*Random(1,var);
            end
            if Psis(psi,var)==2
                valeurpsi=valeurpsi*(Random(1,var)^2-1);
            end
            if Psis(psi,var)==3
                valeurpsi=valeurpsi*(Random(1,var)^3-3*Random(1,var));
            end
            if Psis(psi,var)==4
                valeurpsi=valeurpsi*(Random(1,var)^4-6*Random(1,var)^2+3);
            end
            if Psis(psi,var)==5
                valeurpsi=valeurpsi*(Random(1,var)^5-10*Random(1,var)^3+15*Random(1,var));
            end
            if Psis(psi,var)==6
                valeurpsi=valeurpsi*(Random(1,var)^6-15*Random(1,var)^4+45*Random(1,var)^2-15);
            end
        end
        Output=Output+valeurpsi*F(psi);
    end
    Moments(1,1)=Moments(1,1)+Output;
    Moments(1,2)=Moments(1,2)+(Output-Moy)^2;
    Moments(1,3)=Moments(1,3)+(Output-Moy)^3;
    Moments(1,4)=Moments(1,4)+(Output-Moy)^4;
    Ligne_Output=round((Output-Min)/(Max-Min)*Ninter);
    if Ligne_Output<=1
        Courbes(1,2)=Courbes(1,2)+1;
    elseif Ligne_Output>=Ninter
        Courbes(Ninter,2)=Courbes(Ninter,2)+1;
    else
        Courbes(Ligne_Output,2)=Courbes(Ligne_Output,2)+1;
    end
    for i=1:Ninter
        Courbes(i,4)=Courbes(i,4)+exp(-(Courbes(i,1)-Output)^2/(2*h^2));
    end
end
Moments(1,1)=Moments(1,1)/Nsample;
Moments(1,2)=Moments(1,2)/(Nsample-1);
Moments(1,3)=Moments(1,3)*Nsample/((Nsample-1)*(Nsample-2)*Moments(1,2)^(3/2));
Moments(1,4)=Moments(1,4)*Nsample*(Nsample+1)/((Nsample-1)*(Nsample-2)*(Nsample-3)*Moments(1,2)^2)-3*(Nsample-1)^2/((Nsample-2)*(Nsample-3));
for i=1:Ninter
    Courbes(i,4)=Courbes(i,4)/(Nsample*h*(2*3.1415927)^0.5);
end
Courbes(1,3)=Courbes(1,2);
for i=2:Ninter
    Courbes(i,3)=Courbes(i-1,3)+Courbes(i,2);
end
for i=1:Ninter
    Courbes(i,3)=Courbes(i,3)/Nsample;
end