function Champ=C_Champ_Vitesse2(L1,L2)
%global Couv Diam Coh Gam Qsurf Nteta Nr Nbeta ratioR
C_Values
R=Couv+Diam/2-L1;
%Ri=Diam/2;
%Rf=DeltaR*Ri;
Ri=max([Diam/2-L1,Diam/2+L1]);
Rf=R-L2;
Dbeta=(pi/2)/Nbeta;
Dteta=pi/Nteta;
%Dr=Rf/Nr;

%RMAX INITIAUX
rmaxi=zeros(Nteta,1);
for i=1:Nteta
    teta=pi-(i-0.5)/Nteta*pi;
    A=1+tan(pi/2-teta)^2;
    B=2*L1;
    C=L1^2-(Diam^2*tan(pi/2-teta)^2)/4;
    D=B^2-4*A*C;
    if teta>pi/2
        zi=(-B-D^0.5)/(2*A);
    else
        zi=(-B+D^0.5)/(2*A);
    end
    xi=sqrt(-zi^2+Diam^2/4);
    rmaxi(i)=sqrt((zi+L1)^2+xi^2)/Ri;
end

%VECTEUR DR
vect_dR=zeros(Nr,1);
vect_dR(1,1)=1;
for i=2:Nr
    vect_dR(i,1)=vect_dR(i-1,1)*(1+ratioR);
end
vect_dR=vect_dR/sum(vect_dR)*Rf;


%VITESSES AXIALES
for i=1:Nbeta
    beta=(i-0.5)/Nbeta*pi/2;
    Re=Ri+beta*(Rf-Ri)/(pi/2);
    for j=1:Nr
        Dr=vect_dR(j,1);
        r=sum(vect_dR(1:j-1,1))+Dr/2;
        for k=1:Nteta
            teta=(k-0.5)/Nteta*pi;
            Champ(i,j,k,1)=beta;
            Champ(i,j,k,2)=r;
            Champ(i,j,k,3)=teta;
            Champ(i,j,k,5)=Re;
            rmax=Re*rmaxi(k);
            Champ(i,j,k,4)=rmax;
            if r<rmax
                Vbeta=1-r^2/rmax^2;
                %Vbeta=1-r/rmax;
            else
                Vbeta=0;
            end
            Champ(i,j,k,6)=Vbeta;
        end
    end
end

%DIMENSIONS ELEMENTS ET VOLUMES
for i=1:Nbeta
    for j=1:Nr
        for k=1:Nteta
            Champ(:,j,:,8)=vect_dR(j,1); 
        end
    end
end
Champ(:,:,:,7)=(R-Champ(:,:,:,2).*cos(Champ(:,:,:,3)))*Dbeta;
Champ(:,:,:,9)=Champ(:,:,:,2)*Dteta;
Champ(:,:,:,10)=Champ(:,:,:,7).*Champ(:,:,:,8).*Champ(:,:,:,9);

%NORMALISATION DES VITESSES AXIALES
for i=1:Nbeta
    som=0;
    for j=1:Nr
        for k=1:Nteta
            Vbeta=Champ(i,j,k,6);
            dS=Champ(i,j,k,8)*Champ(i,j,k,9);
            som=som+dS*Vbeta;
        end
    end
    Champ(i,:,:,6)=Champ(i,:,:,6)/som;
end

%VITESSES RADIALES
Champ(1,:,:,11)=(Champ(2,:,:,6)-Champ(1,:,:,6))./Champ(1,:,:,7);
Champ(Nbeta,:,:,11)=(Champ(Nbeta,:,:,6)-Champ(Nbeta-1,:,:,6))./Champ(Nbeta,:,:,7);
for i=2:Nbeta-1
    Champ(i,:,:,11)=(Champ(i+1,:,:,6)-Champ(i-1,:,:,6))./(2*Champ(i,:,:,7));
end

Champ(:,1,:,12)=-Champ(:,1,:,11).*Champ(:,1,:,8)/2;
for j=2:Nr
    rap=(R-Champ(:,j,:,2).*cos(Champ(:,j,:,3))).*Champ(:,j,:,2)./((R-(Champ(:,j,:,2)+vect_dR(j,1)).*cos(Champ(:,j,:,3))).*(Champ(:,j,:,2)+vect_dR(j,1)));
    Champ(:,j,:,12)=(Champ(:,j-1,:,12).*rap-Champ(:,j-1,:,11).*vect_dR(j,1));
end

for i=1:Nbeta
    for j=1:Nr
        for k=1:Nteta
            r=Champ(i,j,k,2);
            rmax=Champ(i,j,k,4);
            if r>rmax
                Champ(i,j,k,12)=0;
            end
        end
    end
end


%DERIVEES CROISEES
Champ(:,1,:,13)=(Champ(:,2,:,6)-Champ(:,1,:,6))./Champ(:,1,:,8);
Champ(:,Nr,:,13)=(Champ(:,Nr,:,6)-Champ(:,Nr-1,:,6))./Champ(:,Nr,:,8);
for j=2:Nr-1
    Champ(:,j,:,13)=(Champ(:,j+1,:,6)-Champ(:,j-1,:,6))./(2*Champ(:,j,:,8));
end

Champ(1,:,:,14)=(Champ(2,:,:,12)-Champ(1,:,:,12))./Champ(1,:,:,7);
Champ(Nbeta,:,:,14)=(Champ(Nbeta,:,:,12)-Champ(Nbeta-1,:,:,12))./Champ(Nbeta,:,:,7);
for i=2:Nbeta-1
    Champ(i,:,:,14)=(Champ(i+1,:,:,12)-Champ(i-1,:,:,12))./(2*Champ(i,:,:,7));
end

Champ(:,:,1,15)=(Champ(:,:,2,12)-Champ(:,:,1,12))./Champ(:,:,1,9);
Champ(:,:,Nteta,15)=(Champ(:,:,Nteta,12)-Champ(:,:,Nteta-1,12))./Champ(:,:,Nteta,9);
for k=2:Nteta-1
    Champ(:,:,k,15)=(Champ(:,:,k+1,12)-Champ(:,:,k-1,12))./(2*Champ(:,:,k,9));
end

%VITESSE VERTICALE
Champ(:,:,:,17)=-Champ(:,:,:,12).*sin(Champ(:,:,:,3));
Champ(:,:,:,18)=-Champ(:,:,:,6).*sin(Champ(:,:,:,1))-Champ(:,:,:,12).*cos(Champ(:,:,:,3)).*cos(Champ(:,:,:,1));
Champ(:,:,:,19)=-Champ(:,:,:,6).*cos(Champ(:,:,:,1))+Champ(:,:,:,12).*cos(Champ(:,:,:,3)).*sin(Champ(:,:,:,1));

%ENGINEERING STRAIN
for i=1:Nbeta
    for j=1:Nr
        for k=1:Nteta
            a=Champ(i,j,k,11);
            b=-Champ(i,j,k,11);
            c=0;
            d=(Champ(i,j,k,13)+Champ(i,j,k,14))/2;
            e=0;
            f=Champ(i,j,k,15)/2;
            Champ(i,j,k,16)=2*max(abs(eig([a,d,e;d,b,f;e,f,c])));
        end
    end
end
