function [Optimum_SigmaC,Optimum_SigmaB,Optimum_Beta,Optimum_R,Safety_Factor,PhySpace,Donnees,Courbes,MomentsMC,MomentsAN,Sobol,SigT_MC,Pf_MC,COV_MC]=Secondary_Program(Type_Computation,Diam,Couv,Coh,Qsurf,Gam,Phi,Ntet,Delta_Beta,Nteta,Nr,Nbeta,SigT,COVPhi,LawPhi,PhiMin,PhiMax,COVCoh,LawCoh,Correl,COVGam,LawGam,COVCouv,LawCouv,MinSigT,MaxSigT,InterSigT,COVSigT,LawSigT,Ordre,Nsample,Interval,Min,Max,h,N_MC)
Optimum_SigmaC=0;
Optimum_SigmaB=0;
Optimum_Beta=0;
Optimum_R=0;
Safety_Factor=0;
PhySpace=0;
Donnees=0;
Courbes=0;
MomentsMC=0;
MomentsAN=0;
Sobol=0;
SigT_MC=0;
Pf_MC=0;
COV_MC=0;

if Type_Computation==1 | Type_Computation==2 | Type_Computation==9
    Start=[25,9];
elseif Type_Computation==3 | Type_Computation==4 | Type_Computation==10
    Start=[30,20];
end


if Type_Computation==1
    Input_Data=[-1,Diam,Couv,Qsurf,Phi,Coh,Gam,Ntet,Delta_Beta];
    save('INPUT.mat','Input_Data');
    options=optimset('TolX',0.1,'Tolfun',0.1);
    [Param_Optim,sig]=fminsearch(@B_Sig,Start,options);
    Optimum_Beta=Param_Optim(1,1)
    Optimum_R=Param_Optim(1,2)
    Optimum_SigmaC=-sig
    B_Trace(Param_Optim)
elseif Type_Computation==2
    Input_Data=[-1,Diam,Couv,Qsurf,Phi,Coh,Gam,Ntet,Delta_Beta,SigT];
    save('INPUT.mat','Input_Data');
    options=optimset('TolX',0.001,'Tolfun',0.001);
    [Fs]=fminsearch(@B_FOS_Sans_Contrainte,cat(2,Start,1),options);
    Optimum_Beta=Fs(1,1)
    Optimum_R=Fs(1,2)
    Safety_Factor=Fs(1,3)
elseif Type_Computation==3
    Input_Data=[1,Diam,Couv,Qsurf,Phi,Coh,Gam,Ntet,Delta_Beta];
    save('INPUT.mat','Input_Data');
    options=optimset('TolX',0.1,'Tolfun',0.1);
    [Param_Optim,sig]=fminsearch(@B_Sig,Start,options);
    Optimum_Beta=Param_Optim(1,1)
    Optimum_R=Param_Optim(1,2)
    Optimum_SigmaB=sig
    B_Trace(Param_Optim)
elseif Type_Computation==4
    Input_Data=[1,Diam,Couv,Qsurf,Phi,Coh,Gam,Ntet,Delta_Beta,SigT];
    save('INPUT.mat','Input_Data');
    options=optimset('TolX',0.001,'Tolfun',0.001);
    [Fs]=fminsearch(@B_FOS_Sans_Contrainte,cat(2,Start,1),options);
    Optimum_Beta=Fs(1,1)
    Optimum_R=Fs(1,2)
    Safety_Factor=Fs(1,3)
elseif Type_Computation==5
    Input_Data=[-1,Diam,Couv,Qsurf,Coh,Gam,Nteta,Nr,Nbeta];
    save('INPUT.mat','Input_Data');
    [Ngamma,Nc,Nq,SigC]=C_Calcul;
    Ngamma
    Nc
    Nq
    Optimum_SigmaC=SigC
elseif Type_Computation==6
    Input_Data=[-1,Diam,Couv,Qsurf,Coh,Gam,Nteta,Nr,Nbeta,SigT];
    save('INPUT.mat','Input_Data');
    options=optimset('TolX',0.0001,'Tolfun',0.0001)
    [Fs]=fminsearch(@C_FOS_Sans_Contrainte,1,options);
    Safety_Factor=Fs
elseif Type_Computation==7
    Input_Data=[1,Diam,Couv,Qsurf,Coh,Gam,Nteta,Nr,Nbeta];
    save('INPUT.mat','Input_Data');
    [Ngamma,Nc,Nq,SigB]=C_Calcul;
    Ngamma
    Nc
    Nq
    Optimum_SigmaB=SigB
elseif Type_Computation==8
    Input_Data=[1,Diam,Couv,Qsurf,Coh,Gam,Nteta,Nr,Nbeta,SigT];
    save('INPUT.mat','Input_Data');
    options=optimset('TolX',0.0001,'Tolfun',0.0001)
    [Fs]=fminsearch(@C_FOS_Sans_Contrainte,1,options);
    Safety_Factor=Fs
elseif Type_Computation>8
    SigT_MC=zeros((MaxSigT-MinSigT)/InterSigT+1,1);
    Pf_MC=zeros((MaxSigT-MinSigT)/InterSigT+1,1);
    COV_MC=zeros((MaxSigT-MinSigT)/InterSigT+1,1);
    SigT_MC(1,1)=MinSigT;
    for i=2:size(SigT_MC,1)
        SigT_MC(i,1)=SigT_MC(i-1,1)+InterSigT;
    end
    RandVar=zeros(1,4);
    if COVPhi>0 & (Type_Computation==9 | Type_Computation==10)
        RandVar(1,1)=1;
    end
    if COVCoh>0
        RandVar(1,2)=1;
    end
    if COVGam>0
        RandVar(1,3)=1;
    end
    if COVCouv>0
        RandVar(1,4)=1;
    end
            
    NVar=sum(RandVar);
    Donnees=A_Donnees(NVar,Ordre);
    if RandVar(1,1:2)==[1,1] & Correl~=0
        XsisC=zeros(size(Donnees,1),size(Donnees,2));
        CorrelMat=diag(ones(NVar,1));
        CorrelMat(1,2)=Correl;
        CorrelMat(2,1)=Correl;
        H=chol(CorrelMat);
        for i=1:size(Donnees,1)
            XsisC(i,:)=transpose(H*transpose(Donnees(i,:)));
        end
    else
        XsisC=Donnees;
    end
    
    PhySpace=zeros(size(Donnees,1),size(Donnees,2));
    Column=0;
    if COVPhi>0 & (Type_Computation==9 | Type_Computation==10)
        Column=Column+1;
        if LawPhi==0
            for i=1:size(PhySpace,1)
                PhySpace(i,Column)=Phi+XsisC(i,Column)*Phi*COVPhi/100;
            end
        else
            [A,B]=A_Gauss_to_Beta((Phi-PhiMin)/(PhiMax-PhiMin),COVPhi,0,1);
            for i=1:size(PhySpace,1)
                PhySpace(i,Column)=PhiMin+(PhiMax-PhiMin)*betainv(normcdf(XsisC(i,Column),0,1),A,B);
            end
        end
    end
    if COVCoh>0
        Column=Column+1;
        if LawCoh==0
            for i=1:size(PhySpace,1)
                PhySpace(i,Column)=Coh+XsisC(i,Column)*Coh*COVCoh/100;
            end
        else
            [MuLog,SigLog]=A_Gauss_to_Log(Coh,Coh*COVCoh/100);
            for i=1:size(PhySpace,1)
                PhySpace(i,Column)=logninv(normcdf(XsisC(i,Column),0,1),MuLog,SigLog);
            end
        end
    end
    if COVGam>0
        Column=Column+1;
        if LawGam==0
            for i=1:size(PhySpace,1)
                PhySpace(i,Column)=Gam+XsisC(i,Column)*Gam*COVGam/100;
            end
        else
            [MuLog,SigLog]=A_Gauss_to_Log(Gam,Gam*COVGam/100);
            for i=1:size(PhySpace,1)
                PhySpace(i,Column)=logninv(normcdf(XsisC(i,Column),0,1),MuLog,SigLog);
            end
        end
    end
    if COVCouv>0
        Column=Column+1;
        if LawCouv==0
            for i=1:size(PhySpace,1)
                PhySpace(i,Column)=Couv+XsisC(i,Column)*Couv*COVCouv/100;
            end
        else
            [MuLog,SigLog]=A_Gauss_to_Log(Couv,Couv*COVCouv/100);
            for i=1:size(PhySpace,1)
                PhySpace(i,Column)=logninv(normcdf(XsisC(i,Column),0,1),MuLog,SigLog);
            end
        end
    end
    n=1;
    for i=1:4
        if RandVar(1,i)>0
            RandVar(2,i)=n;
            n=n+1;
        end
    end
    
    if Type_Computation==9
        Calcs=-1*ones(size(Donnees,1),1);
        Calcs(:,2)=Diam*ones(size(Donnees,1),1);
        Column=0;
        if RandVar(1,4)==1
            Calcs(:,3)=PhySpace(:,RandVar(2,4));
        else
            Calcs(:,3)=Couv*ones(size(Donnees,1),1);
        end
        Calcs(:,4)=Qsurf*ones(size(Donnees,1),1);
        if RandVar(1,1)==1
            Calcs(:,5)=PhySpace(:,RandVar(2,1));
        else
            Calcs(:,5)=Phi*ones(size(Donnees,1),1);
        end
        if RandVar(1,2)==1 & Coh>0
            Calcs(:,6)=PhySpace(:,RandVar(2,2));
        else
            Calcs(:,6)=Coh*ones(size(Donnees,1),1);
        end
        if RandVar(1,3)==1
            Calcs(:,7)=PhySpace(:,RandVar(2,3));
        else
            Calcs(:,7)=Gam*ones(size(Donnees,1),1);
        end
        Calcs(:,8)=Ntet*ones(size(Donnees,1),1);
        Calcs(:,9)=Delta_Beta*ones(size(Donnees,1),1);
        for i=1:size(Calcs,1)
            Input_Data=Calcs(i,:);
            save('INPUT.mat','Input_Data');
            options=optimset('TolX',0.1,'Tolfun',0.1);
            [Param_Optim,sig]=fminsearch(@B_Sig,Start,options);
            Donnees(i,NVar+1)=-sig;
        end
        RuptSupInf=1;
        [F,Psis]=A_fonction_F(Donnees,Ordre)
        [Courbes,MomentsMC]=A_Monte_Carlo(F,Psis,Nsample,Interval,Min,Max,h);
        MomentsMC
        MomentsAN=A_Moments_analytiques(F,Psis,Ordre)
        Sobol=A_Indices_Sobol(F,Psis)
        for i=1:size(SigT_MC,1)
            S=SigT_MC(i,1)
            [P,C]=A_FiabMC(F,Psis,S,COVSigT,LawSigT,RuptSupInf,N_MC);
            Pf_MC(i,1)=P;
            COV_MC(i,1)=C;
        end
        cat(2,SigT_MC,Pf_MC)
    elseif Type_Computation==10
        Calcs=ones(size(Donnees,1),1);
        Calcs(:,2)=Diam*ones(size(Donnees,1),1);
        Column=0;
        if RandVar(1,4)==1
            Calcs(:,3)=PhySpace(:,RandVar(2,4));
        else
            Calcs(:,3)=Couv*ones(size(Donnees,1),1);
        end
        Calcs(:,4)=Qsurf*ones(size(Donnees,1),1);
        if RandVar(1,1)==1
            Calcs(:,5)=PhySpace(:,RandVar(2,1));
        else
            Calcs(:,5)=Phi*ones(size(Donnees,1),1);
        end
        if RandVar(1,2)==1 & Coh>0
            Calcs(:,6)=PhySpace(:,RandVar(2,2));
        else
            Calcs(:,6)=Coh*ones(size(Donnees,1),1);
        end
        if RandVar(1,3)==1
            Calcs(:,7)=PhySpace(:,RandVar(2,3));
        else
            Calcs(:,7)=Gam*ones(size(Donnees,1),1);
        end
        Calcs(:,8)=Ntet*ones(size(Donnees,1),1);
        Calcs(:,9)=Delta_Beta*ones(size(Donnees,1),1);
        for i=1:size(Calcs,1)
            Input_Data=Calcs(i,:);
            save('INPUT.mat','Input_Data');
            options=optimset('TolX',0.1,'Tolfun',0.1);
            [Param_Optim,sig]=fminsearch(@B_Sig,Start,options);
            Donnees(i,NVar+1)=sig;
        end
        RuptSupInf=-1;
        [F,Psis]=A_fonction_F(Donnees,Ordre)
        [Courbes,MomentsMC]=A_Monte_Carlo(F,Psis,Nsample,Interval,Min,Max,h);
        MomentsMC
        MomentsAN=A_Moments_analytiques(F,Psis,Ordre)
        Sobol=A_Indices_Sobol(F,Psis)
        for i=1:size(SigT_MC,1)
            S=SigT_MC(i,1)
            [P,C]=A_FiabMC(F,Psis,S,COVSigT,LawSigT,RuptSupInf,N_MC);
            Pf_MC(i,1)=P;
            COV_MC(i,1)=C;
        end
        cat(2,SigT_MC,Pf_MC)
    elseif Type_Computation==11
        Calcs=-ones(size(Donnees,1),1);
        Calcs(:,2)=Diam*ones(size(Donnees,1),1);
        Column=0;
        if RandVar(1,4)==1
            Calcs(:,3)=PhySpace(:,RandVar(2,4));
        else
            Calcs(:,3)=Couv*ones(size(Donnees,1),1);
        end
        Calcs(:,4)=Qsurf*ones(size(Donnees,1),1);
        if RandVar(1,2)==1 & Coh>0
            Calcs(:,5)=PhySpace(:,RandVar(2,2));
        else
            Calcs(:,5)=Coh*ones(size(Donnees,1),1);
        end
        if RandVar(1,3)==1
            Calcs(:,6)=PhySpace(:,RandVar(2,3));
        else
            Calcs(:,6)=Gam*ones(size(Donnees,1),1);
        end
        Calcs(:,7)=Nteta*ones(size(Donnees,1),1);
        Calcs(:,8)=Nr*ones(size(Donnees,1),1);
        Calcs(:,9)=Nbeta*ones(size(Donnees,1),1);
        for NN=1:size(Calcs,1)
            Input_Data=Calcs(NN,:);
            save('INPUT.mat','Input_Data');
            [Ngamma,Nc,Nq,SigC]=C_Calcul;
            Donnees(NN,NVar+1)=SigC
        end
        RuptSupInf=1;
        [F,Psis]=A_fonction_F(Donnees,Ordre)
        [Courbes,MomentsMC]=A_Monte_Carlo(F,Psis,Nsample,Interval,Min,Max,h);
        MomentsMC
        MomentsAN=A_Moments_analytiques(F,Psis,Ordre)
        Sobol=A_Indices_Sobol(F,Psis)
        for i=1:size(SigT_MC,1)
            S=SigT_MC(i,1)
            [P,C]=A_FiabMC(F,Psis,S,COVSigT,LawSigT,RuptSupInf,N_MC);
            Pf_MC(i,1)=P;
            COV_MC(i,1)=C;
        end
        cat(2,SigT_MC,Pf_MC)
    elseif Type_Computation==12
        Calcs=ones(size(Donnees,1),1);
        Calcs(:,2)=Diam*ones(size(Donnees,1),1);
        Column=0;
        if RandVar(1,4)==1
            Calcs(:,3)=PhySpace(:,RandVar(2,4));
        else
            Calcs(:,3)=Couv*ones(size(Donnees,1),1);
        end
        Calcs(:,4)=Qsurf*ones(size(Donnees,1),1);
        if RandVar(1,2)==1 & Coh>0
            Calcs(:,5)=PhySpace(:,RandVar(2,2));
        else
            Calcs(:,5)=Coh*ones(size(Donnees,1),1);
        end
        if RandVar(1,3)==1
            Calcs(:,6)=PhySpace(:,RandVar(2,3));
        else
            Calcs(:,6)=Gam*ones(size(Donnees,1),1);
        end
        Calcs(:,7)=Nteta*ones(size(Donnees,1),1);
        Calcs(:,8)=Nr*ones(size(Donnees,1),1);
        Calcs(:,9)=Nbeta*ones(size(Donnees,1),1);
        for NN=1:size(Calcs,1)
            Input_Data=Calcs(NN,:);
            save('INPUT.mat','Input_Data');
            [Ngamma,Nc,Nq,SigB]=C_Calcul;
            Donnees(NN,NVar+1)=SigB
        end
        RuptSupInf=-1;
        [F,Psis]=A_fonction_F(Donnees,Ordre)
        [Courbes,MomentsMC]=A_Monte_Carlo(F,Psis,Nsample,Interval,Min,Max,h);
        MomentsMC
        MomentsAN=A_Moments_analytiques(F,Psis,Ordre)
        Sobol=A_Indices_Sobol(F,Psis)
        for i=1:size(SigT_MC,1)
            S=SigT_MC(i,1)
            [P,C]=A_FiabMC(F,Psis,S,COVSigT,LawSigT,RuptSupInf,N_MC);
            Pf_MC(i,1)=P;
            COV_MC(i,1)=C;
        end
        cat(2,SigT_MC,Pf_MC)
    end
end
